/*!
 * @copyright Copyright &copy; Kartik Visweswaran, Krajee.com, 2014 - 2015
 * @version 4.1.8
 *
 * File input styled for Bootstrap 3.0 that utilizes HTML5 File Input's advanced 
 * features including the FileReader API. 
 * 
 * The plugin drastically enhances the HTML file input to preview multiple files on the client before
 * upload. In addition it provides the ability to preview content of images, text, videos, audio, html, 
 * flash and other objects. It also offers the ability to upload and delete files using AJAX, and add 
 * files in batches (i.e. preview, append, or remove before upload).
 * 
 * Author: Kartik Visweswaran
 * Copyright: 2015, Kartik Visweswaran, Krajee.com
 * For more JQuery plugins visit http://plugins.krajee.com
 * For more Yii related demos visit http://demos.krajee.com
 */!function(e){"use strict";String.prototype.repl=function(e,i){return this.split(e).join(i)};var i=function(e){var i,t=document.createElement("div");return t.innerHTML="<!--[if IE "+e+"]><i></i><![endif]-->",i=1===t.getElementsByTagName("i").length,document.body.appendChild(t),t.parentNode.removeChild(t),i},t=function(){return window.File&&window.FileReader},a=function(){var e=document.createElement("div");return!i(9)&&(void 0!==e.draggable||void 0!==e.ondragstart&&void 0!==e.ondrop)},r=function(){return t&&window.FormData},n=function(e,i){e.removeClass(i).addClass(i)},l='style="width:{width};height:{height};"',o='      <param name="controller" value="true" />\n      <param name="allowFullScreen" value="true" />\n      <param name="allowScriptAccess" value="always" />\n      <param name="autoPlay" value="false" />\n      <param name="autoStart" value="false" />\n      <param name="quality" value="high" />\n',s='<div class="file-preview-other">\n       <i class="glyphicon glyphicon-file"></i>\n   </div>',d={removeIcon:'<i class="glyphicon glyphicon-trash text-danger"></i>',removeClass:"btn btn-xs btn-default",removeTitle:"Remove file",uploadIcon:'<i class="glyphicon glyphicon-upload text-info"></i>',uploadClass:"btn btn-xs btn-default",uploadTitle:"Upload file",indicatorNew:'<i class="glyphicon glyphicon-hand-down text-warning"></i>',indicatorSuccess:'<i class="glyphicon glyphicon-ok-sign file-icon-large text-success"></i>',indicatorError:'<i class="glyphicon glyphicon-exclamation-sign text-danger"></i>',indicatorLoading:'<i class="glyphicon glyphicon-hand-up text-muted"></i>',indicatorNewTitle:"Not uploaded yet",indicatorSuccessTitle:"Uploaded",indicatorErrorTitle:"Upload Error",indicatorLoadingTitle:"Uploading ..."},p='{preview}\n<div class="kv-upload-progress hide"></div>\n<div class="input-group {class}">\n   {caption}\n   <div class="input-group-btn">\n       {remove}\n       {cancel}\n       {upload}\n       {browse}\n   </div>\n</div>',c='{preview}\n<div class="kv-upload-progress hide"></div>\n{remove}\n{cancel}\n{upload}\n{browse}\n',f='<div class="file-preview {class}">\n    <div class="close fileinput-remove">&times;</div>\n    <div class="{dropClass}">\n    <div class="file-preview-thumbnails">\n    </div>\n    <div class="clearfix"></div>    <div class="file-preview-status text-center text-success"></div>\n    <div class="kv-fileinput-error"></div>\n    </div>\n</div>',u='<span class="glyphicon glyphicon-file kv-caption-icon"></span>',v='<div tabindex="-1" class="form-control file-caption {class}">\n   <span class="file-caption-ellipsis">&hellip;</span>\n   <div class="file-caption-name"></div>\n</div>',h='<div id="{id}" class="modal fade">\n  <div class="modal-dialog modal-lg">\n    <div class="modal-content">\n      <div class="modal-header">\n        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>\n        <h3 class="modal-title">Detailed Preview <small>{title}</small></h3>\n      </div>\n      <div class="modal-body">\n        <textarea class="form-control" style="font-family:Monaco,Consolas,monospace; height: {height}px;" readonly>{body}</textarea>\n      </div>\n    </div>\n  </div>\n</div>',m='<div class="progress">\n    <div class="{class}" role="progressbar" aria-valuenow="{percent}" aria-valuemin="0" aria-valuemax="100" style="width:{percent}%;">\n        {percent}%\n     </div>\n</div>',g='<div class="file-thumbnail-footer">\n    <div class="file-caption-name">{caption}</div>\n    {actions}\n</div>',w='<div class="file-actions">\n    <div class="file-footer-buttons">\n        {upload}{delete}{other}    </div>\n    <div class="file-upload-indicator" tabindex="-1" title="{indicatorTitle}">{indicator}</div>\n    <div class="clearfix"></div>\n</div>',b='<button type="button" class="kv-file-remove {removeClass}" title="{removeTitle}"{dataUrl}{dataKey}>{removeIcon}</button>\n',C='<button type="button" class="kv-file-upload {uploadClass}" title="{uploadTitle}">   {uploadIcon}\n</button>\n',x='<div class="file-preview-frame{frameClass}" id="{previewId}" data-fileindex="{fileindex}">\n   {content}\n   {footer}\n</div>\n',y='<div class="file-preview-frame{frameClass}" id="{previewId}" data-fileindex="{fileindex}">\n    <object data="{data}" type="{type}" width="{width}" height="{height}">\n       '+s+"\n    </object>\n   {footer}\n</div>",$='<div class="file-preview-frame{frameClass}" id="{previewId}" data-fileindex="{fileindex}">\n   <img src="{data}" class="file-preview-image" title="{caption}" alt="{caption}" '+l+">\n   {footer}\n</div>\n",k='<div class="file-preview-frame{frameClass}" id="{previewId}" data-fileindex="{fileindex}">\n   <div class="file-preview-text" title="{caption}" '+l+">\n       {data}\n   </div>\n   {footer}\n</div>",T='<div class="file-preview-frame{frameClass}" id="{previewId}" data-fileindex="{fileindex}" title="{caption}" '+l+'>\n   <video width="{width}" height="{height}" controls>\n       <source src="{data}" type="{type}">\n       '+s+"\n   </video>\n   {footer}\n</div>\n",E='<div class="file-preview-frame{frameClass}" id="{previewId}" data-fileindex="{fileindex}" title="{caption}" '+l+'>\n   <audio controls>\n       <source src="{data}" type="{type}">\n       '+s+"\n   </audio>\n   {footer}\n</div>",F='<div class="file-preview-frame{frameClass}" id="{previewId}" data-fileindex="{fileindex}" title="{caption}" '+l+'>\n   <object type="application/x-shockwave-flash" width="{width}" height="{height}" data="{data}">\n'+o+"       "+s+"\n   </object>\n   {footer}\n</div>\n",P='<div class="file-preview-frame{frameClass}" id="{previewId}" data-fileindex="{fileindex}" title="{caption}" '+l+'>\n   <object data="{data}" type="{type}" width="{width}" height="{height}">\n       <param name="movie" value="{caption}" />\n'+o+"         "+s+"\n   </object>\n   {footer}\n</div>",I='<div class="file-preview-frame{frameClass}" id="{previewId}" data-fileindex="{fileindex}" title="{caption}" '+l+">\n   "+s+"\n   {footer}\n</div>",D={main1:p,main2:c,preview:f,icon:u,caption:v,modal:h,progress:m,footer:g,actions:w,actionDelete:b,actionUpload:C},S={generic:x,html:y,image:$,text:k,video:T,audio:E,flash:F,object:P,other:I},U=["image","html","text","video","audio","flash","object"],j={image:{width:"auto",height:"160px"},html:{width:"213px",height:"160px"},text:{width:"160px",height:"160px"},video:{width:"213px",height:"160px"},audio:{width:"213px",height:"80px"},flash:{width:"213px",height:"160px"},object:{width:"160px",height:"160px"},other:{width:"160px",height:"160px"}},A={image:function(e,i){return void 0!==e?e.match("image.*"):i.match(/\.(gif|png|jpe?g)$/i)},html:function(e,i){return void 0!==e?"text/html"===e:i.match(/\.(htm|html)$/i)},text:function(e,i){return void 0!==e&&e.match("text.*")||i.match(/\.(txt|md|csv|nfo|php|ini)$/i)},video:function(e,i){return void 0!==e&&e.match(/\.video\/(ogg|mp4|webm)$/i)||i.match(/\.(og?|mp4|webm)$/i)},audio:function(e,i){return void 0!==e&&e.match(/\.audio\/(ogg|mp3|wav)$/i)||i.match(/\.(ogg|mp3|wav)$/i)},flash:function(e,i){return void 0!==e&&"application/x-shockwave-flash"===e||i.match(/\.(swf)$/i)},object:function(){return!0},other:function(){return!0}},L=function(i,t){return null===i||void 0===i||0===i.length||t&&""===e.trim(i)},O=function(e){return Array.isArray(e)||"[object Array]"===Object.prototype.toString.call(e)},R=function(e,i){return"object"==typeof i&&e in i},z=function(i,t,a){return L(i)||L(i[t])?a:e(i[t])},M=function(){return Math.round((new Date).getTime()+100*Math.random())},Z=function(e){return String(e).repl("&","&amp;").repl('"',"&quot;").repl("'","&#39;").repl("<","&lt;").repl(">","&gt;")},B=function(i,t){var a=i;return e.each(t,function(e,i){"function"==typeof i&&(i=i()),a=a.repl(e,i)}),a},N=window.URL||window.webkitURL,_=function(a,r){this.$element=e(a),t()||i(9)?(this.init(r),this.listen()):this.$element.removeClass("file-loading")};_.prototype={constructor:_,init:function(t){var l,o,s=this,p=s.$element;e.each(t,function(e,i){s[e]=i}),L(s.allowedPreviewTypes)&&(s.allowedPreviewTypes=U),s.uploadFileAttr=L(p.attr("name"))?"file_data":p.attr("name"),s.reader=null,s.formdata={},s.isIE9=i(9),s.isIE10=i(10),s.filestack=[],s.ajaxRequests=[],s.isError=!1,s.dropZoneEnabled=a()&&s.dropZoneEnabled,s.isDisabled=s.$element.attr("disabled")||s.$element.attr("readonly"),s.isUploadable=r&&!L(s.uploadUrl),s.slug="function"==typeof t.slugCallback?t.slugCallback:s.slugDefault,s.mainTemplate=s.getLayoutTemplate(s.showCaption?"main1":"main2"),s.captionTemplate=s.getLayoutTemplate("caption"),s.previewGenericTemplate=s.getPreviewTemplate("generic"),L(s.$element.attr("id"))&&s.$element.attr("id",M()),void 0===s.$container?s.$container=s.createContainer():s.refreshContainer(),s.$progress=s.$container.find(".kv-upload-progress"),s.$btnUpload=s.$container.find(".kv-fileinput-upload"),s.$captionContainer=z(t,"elCaptionContainer",s.$container.find(".file-caption")),s.$caption=z(t,"elCaptionText",s.$container.find(".file-caption-name")),s.$previewContainer=z(t,"elPreviewContainer",s.$container.find(".file-preview")),s.$preview=z(t,"elPreviewImage",s.$container.find(".file-preview-thumbnails")),s.$previewStatus=z(t,"elPreviewStatus",s.$container.find(".file-preview-status")),s.$errorContainer=z(t,"elErrorContainer",s.$previewContainer.find(".kv-fileinput-error")),L(s.msgErrorClass)||n(s.$errorContainer,s.msgErrorClass),s.$errorContainer.hide(),s.initialPreviewContent="",l=s.initialPreview,s.initialPreviewCount=O(l)?l.length:l.length>0?l.split(s.initialPreviewDelimiter).length:0,s.fileActionSettings=e.extend(d,t.fileActionSettings),s.previewInitId="preview-"+M(),s.initPreview(),s.initPreviewDeletes(),s.original={preview:s.$preview.html(),caption:s.$caption.html()},s.options=t,s.setFileDropZoneTitle(),s.uploadCount=0,s.uploadPercent=0,s.$element.removeClass("file-loading"),o=s.getLayoutTemplate("progress"),s.progressTemplate=o.replace("{class}",s.progressClass),s.progressCompleteTemplate=o.replace("{class}",s.progressCompleteClass),s.setEllipsis()},raise:function(e,i){var t=this;void 0!==i?t.$element.trigger(e,i):t.$element.trigger(e)},getLayoutTemplate:function(e){var i=this,t=R(e,i.layoutTemplates)?i.layoutTemplates[e]:D[e];return L(i.customLayoutTags)?t:B(t,i.customLayoutTags)},getPreviewTemplate:function(e){var i=this,t=R(e,i.previewTemplates)?i.previewTemplates[e]:S[e];return L(i.customPreviewTags)?t:B(t,i.customPreviewTags)},getOutData:function(e,i,t){var a=this;return e=e||{},i=i||{},t=t||a.filestack.slice(0)||{},{form:a.formdata,files:t,extra:a.getExtraData(),response:i,reader:a.reader,jqXHR:e}},setEllipsis:function(){var e=this,i=e.$captionContainer,t=e.$caption,a=t.clone().css("height","auto").hide();i.parent().before(a),i.removeClass("kv-has-ellipsis"),a.outerWidth()>t.outerWidth()&&i.addClass("kv-has-ellipsis"),a.remove()},listen:function(){var i=this,t=i.$element,a=i.$captionContainer,r=i.$btnFile;t.on("change",e.proxy(i.change,i)),e(window).on("resize",function(){i.setEllipsis()}),r.off("click").on("click",function(){i.raise("filebrowse"),i.isError&&!i.isUploadable&&i.clear(!0),a.focus()}),t.closest("form").off("reset").on("reset",e.proxy(i.reset,i)),i.$container.off("click").on("click",".fileinput-remove:not([disabled])",e.proxy(i.clear,i)).on("click",".fileinput-cancel",e.proxy(i.cancel,i)),i.isUploadable&&i.dropZoneEnabled&&i.showPreview&&i.initDragDrop(),i.isUploadable&&i.$container.find(".kv-fileinput-upload").off("click").on("click",function(t){i.isUploadable&&(t.preventDefault(),!e(this).hasClass("disabled")&&L(e(this).attr("disabled"))&&i.upload())})},setProgress:function(e){var i=this,t=Math.min(e,100),a=100>t?i.progressTemplate:i.progressCompleteTemplate;i.$progress.html(a.repl("{percent}",t))},upload:function(){var i,t,a,r=this,n=r.getFileStack().length,l=!e.isEmptyObject(r.getExtraData());if(r.isUploadable&&!r.isDisabled&&(0!==n||l)){if(r.resetUpload(),r.$progress.removeClass("hide"),r.uploadCount=0,r.uploadPercent=0,r.lock(),r.setProgress(0),0===n&&l)return void r.uploadExtraOnly();if(a=r.filestack.length,!r.uploadAsync&&1!==n||!r.showPreview)r.uploadBatch();else for(t=r.getOutData(),r.raise("filebatchpreupload",[t]),i=0;a>i;i+=1)void 0!==r.filestack[i]&&r.uploadSingle(i,r.filestack,!0)}},lock:function(){var e=this;e.resetErrors(),e.disable(),e.showRemove&&n(e.$container.find(".fileinput-remove"),"hide"),e.showCancel&&e.$container.find(".fileinput-cancel").removeClass("hide"),e.raise("filelock",[e.filestack,e.getExtraData()])},unlock:function(e){var i=this;void 0===e&&(e=!0),i.enable(),i.showCancel&&n(i.$container.find(".fileinput-cancel"),"hide"),i.showRemove&&i.$container.find(".fileinput-remove").removeClass("hide"),e&&i.resetFileStack(),i.raise("fileunlock",[i.filestack,i.getExtraData()])},resetFileStack:function(){var i=this,t=0,a=[];i.$preview.find(".file-preview-frame").each(function(){var r=e(this),n=r.attr("data-fileindex"),l=i.filestack[n];-1!=n&&(void 0!==l?(a[t]=l,r.attr({id:i.previewInitId+"-"+t,"data-fileindex":t}),t+=1):r.attr({id:"uploaded-"+M(),"data-fileindex":"-1"}))}),i.filestack=a},refresh:function(i){var t,a=this,r=a.$element,n=arguments.length?e.extend(a.options,i):a.options;r.off(),a.init(n),t=a.$container.find(".file-drop-zone"),t.off("dragenter dragover drop"),e(document).off("dragenter dragover drop"),a.listen(),a.setFileDropZoneTitle()},initDragDrop:function(){var i=this,t=i.$container.find(".file-drop-zone");t.off("dragenter dragover drop"),e(document).off("dragenter dragover drop"),t.on("dragenter dragover",function(t){t.stopPropagation(),t.preventDefault(),i.isDisabled||n(e(this),"highlighted")}),t.on("dragleave",function(t){t.stopPropagation(),t.preventDefault(),i.isDisabled||e(this).removeClass("highlighted")}),t.on("drop",function(t){t.preventDefault(),i.isDisabled||(i.change(t,"dragdrop"),e(this).removeClass("highlighted"))}),e(document).on("dragenter dragover drop",function(e){e.stopPropagation(),e.preventDefault()})},setFileDropZoneTitle:function(){var e=this,i=e.$container.find(".file-drop-zone");i.find("."+e.dropZoneTitleClass).remove(),e.isUploadable&&e.showPreview&&0!==i.length&&!(e.getFileStack().length>0)&&e.dropZoneEnabled&&(0===i.find(".file-preview-frame").length&&i.prepend('<div class="'+e.dropZoneTitleClass+'">'+e.dropZoneTitle+"</div>"),e.$container.removeClass("file-input-new"),n(e.$container,"file-input-ajax-new"))},initFileActions:function(){var i=this;i.$preview.find(".kv-file-remove").each(function(){var t,a,r=e(this),n=r.closest(".file-preview-frame"),l=n.attr("data-fileindex");r.off("click").on("click",function(){n.fadeOut("slow",function(){i.filestack[l]=void 0,i.clearObjects(n),n.remove();var e=i.getFileStack(),r=e.length,o=i.$container.find(".file-preview-initial").length;0===r&&0===o?(i.original.preview="",i.reset()):(t=i.initialPreviewCount+r,a=t>1?i.msgSelected.repl("{n}",t):e[0].name,i.setCaption(a))})})}),i.$preview.find(".kv-file-upload").each(function(){var t=e(this);t.off("click").on("click",function(){var e=t.closest(".file-preview-frame"),a=e.attr("data-fileindex");i.uploadSingle(a,i.filestack,!1)})})},renderInitFileFooter:function(e){if(0===this.initialPreviewConfig.length||L(this.initialPreviewConfig[e]))return"";var i=this,t=i.getLayoutTemplate("footer"),a=i.initialPreviewConfig[e],r=R("caption",a)?a.caption:"",n=R("width",a)?a.width:"auto",l=R("url",a)?a.url:!1,o=R("key",a)?a.key:null,s=l===!1,d=i.initialPreviewShowDelete?i.renderFileActions(!1,!0,s,l,o):"",p=t.repl("{actions}",d);return p.repl("{caption}",r).repl("{width}",n).repl("{indicator}","").repl("{indicatorTitle}","")},renderFileFooter:function(e,i){var t,a=this,r=a.fileActionSettings,n=a.getLayoutTemplate("footer");return a.isUploadable?(t=n.repl("{actions}",a.renderFileActions(!0,!0,!1,!1,!1)),t.repl("{caption}",e).repl("{width}",i).repl("{indicator}",r.indicatorNew).repl("{indicatorTitle}",r.indicatorNewTitle)):n.repl("{actions}","").repl("{caption}",e).repl("{width}",i).repl("{indicator}","").repl("{indicatorTitle}","")},renderFileActions:function(e,i,t,a,r){if(!e&&!i)return"";var n=this,l=a===!1?"":' data-url="'+a+'"',o=r===!1?"":' data-key="'+r+'"',s=n.getLayoutTemplate("actionDelete"),d="",p=n.getLayoutTemplate("actions"),c=n.otherActionButtons.repl("{dataKey}",o),f=n.fileActionSettings,u=t?f.removeClass+" disabled":f.removeClass;return s=s.repl("{removeClass}",u).repl("{removeIcon}",f.removeIcon).repl("{removeTitle}",f.removeTitle).repl("{dataUrl}",l).repl("{dataKey}",o),e&&(d=n.getLayoutTemplate("actionUpload").repl("{uploadClass}",f.uploadClass).repl("{uploadIcon}",f.uploadIcon).repl("{uploadTitle}",f.uploadTitle)),p.repl("{delete}",s).repl("{upload}",d).repl("{other}",c)},getInitialPreview:function(e,i,t){var a=this,r="init_"+t,n=a.previewInitId+"-"+r,l=a.renderInitFileFooter(t,!1);return e.repl("{previewId}",n).repl("{frameClass}"," file-preview-initial").repl("{fileindex}",r).repl("{content}",i).repl("{footer}",l)},initPreview:function(){var e,i,t=this,a="",r=t.initialPreview,n=t.initialPreviewCount,l=t.initialCaption.length,o=l>0?t.initialCaption:t.msgSelected.repl("{n}",n);if(O(r)&&n>0){for(e=0;n>e;e+=1)a+=t.getInitialPreview(t.previewGenericTemplate,r[e],e);n>1&&0===l&&(o=t.msgSelected.repl("{n}",n))}else{if(!(n>0))return void(l>0&&t.setCaption(o));for(i=r.split(t.initialPreviewDelimiter),e=0;n>e;e+=1)a+=t.getInitialPreview(t.previewGenericTemplate,i[e],e);n>1&&0===l&&(o=t.msgSelected.repl("{n}",n))}t.initialPreviewContent=a,t.$preview.html(a),t.setCaption(o),t.$container.removeClass("file-input-new")},initPreviewDeletes:function(){var i,t,a=this,r=a.deleteExtraData||{},l=function(){0===a.$preview.find(".kv-file-remove").length&&a.reset()};"function"==typeof r&&(r=r()),a.$preview.find(".kv-file-remove").each(function(){var o,s=e(this),d=s.closest(".file-preview-frame"),p=s.attr("data-url"),c=s.attr("data-key");void 0!==p&&void 0!==c&&s.off("click").on("click",function(){e.ajax({url:p,type:"POST",dataType:"json",data:{key:c,extraData:r},beforeSend:function(e){n(d,"file-uploading"),n(s,"disabled"),a.raise("filepredelete",[c,e,r])},success:function(n,p,f){void 0===n.error?a.raise("filedeleted",[c,f,r]):(a.showError(n.error,r,s.attr("id"),c,"filedeleteerror",f),l()),d.removeClass("file-uploading").addClass("file-deleted"),d.fadeOut("slow",function(){a.clearObjects(d),d.remove(),o=e(document.createElement("div")).html(a.original.preview),o.find(".file-preview-frame").each(function(){t=e(this),t.find(".kv-file-remove").attr("data-key")==c&&t.remove()}),a.initialPreviewContent=o.html(),a.initialPreviewCount>0&&(a.initialPreviewCount-=1),i=a.initialCaption,0===a.initialCaption.length&&(i=a.msgSelected.repl("{n}",a.initialPreviewCount)),a.original.preview=o.html(),a.setCaption(i),a.original.caption=a.$caption.html(),o.remove(),l()})},error:function(e,i,t){a.showError(t,r,s.attr("id"),c,"filedeleteerror",e),d.removeClass("file-uploading"),l()}})})})},clearObjects:function(i){i.find("video audio").each(function(){this.pause(),e(this).remove()}),i.find("img object div").each(function(){e(this).remove()})},clearFileInput:function(){var i,t,a,r=this,n=r.$element;L(n.val())||(r.isIE9||r.isIE10?(i=n.closest("form"),t=e(document.createElement("form")),a=e(document.createElement("div")),n.before(a),i.length?i.after(t):a.after(t),t.append(n).trigger("reset"),a.before(n).remove(),t.remove()):n.val(""))},resetUpload:function(){var e=this;e.uploadCount=0,e.uploadPercent=0,e.$btnUpload.removeAttr("disabled"),e.setProgress(0),n(e.$progress,"hide"),e.resetErrors(!1),e.ajaxRequests=[]},cancel:function(){var i,t=this,a=t.ajaxRequests,r=a.length;if(r>0)for(i=0;r>i;i+=1)a[i].abort();t.$preview.find(".file-preview-frame").each(function(){var i=e(this),a=i.attr("data-fileindex");i.removeClass("file-uploading"),void 0!==t.filestack[a]&&(i.find(".kv-file-upload").removeClass("disabled").removeAttr("disabled"),i.find(".kv-file-remove").removeClass("disabled").removeAttr("disabled")),t.unlock()})},clear:function(i){var t,a=this;!a.isIE9&&a.reader instanceof FileReader&&a.reader.abort(),a.$btnUpload.removeAttr("disabled"),a.resetUpload(),a.filestack=[],a.clearFileInput(),a.resetErrors(!0),i!==!0&&(a.raise("change"),a.raise("fileclear")),a.overwriteInitial&&(a.initialPreviewCount=0,a.initialPreviewContent=""),!a.overwriteInitial&&a.initialPreviewContent.length>0?(a.showFileIcon(),a.$preview.html(a.original.preview),a.$caption.html(a.original.caption),a.setEllipsis(),a.initPreviewDeletes(),a.$container.removeClass("file-input-new")):(a.$preview.find(".file-preview-frame").each(function(){a.clearObjects(e(this))}),a.$preview.html(""),t=!a.overwriteInitial&&a.initialCaption.length>0?a.original.caption:"",a.$caption.html(t),a.setEllipsis(),a.$caption.attr("title",""),n(a.$container,"file-input-new")),0===a.$container.find(".file-preview-frame").length&&(a.initialCaption="",a.original.caption="",a.$caption.html(""),a.setEllipsis(),a.$captionContainer.find(".kv-caption-icon").hide()),a.hideFileIcon(),a.raise("filecleared"),a.$captionContainer.focus(),a.setFileDropZoneTitle()},reset:function(){var e=this;e.clear(!0),e.$preview.html(e.original.preview),e.$caption.html(e.original.caption),e.setEllipsis(),e.$container.find(".fileinput-filename").text(""),e.raise("filereset"),e.initialPreview.length>0&&e.$container.removeClass("file-input-new"),e.setFileDropZoneTitle(),e.isUploadable&&e.resetUpload(),e.filestack=[],e.formdata={}},disable:function(){var e=this;e.isDisabled=!0,e.raise("filedisabled"),e.$element.attr("disabled","disabled"),e.$container.find(".kv-fileinput-caption").addClass("file-caption-disabled"),e.$container.find(".btn-file, .fileinput-remove, .kv-fileinput-upload").attr("disabled",!0),e.initDragDrop()},enable:function(){var e=this;e.isDisabled=!1,e.raise("fileenabled"),e.$element.removeAttr("disabled"),e.$container.find(".kv-fileinput-caption").removeClass("file-caption-disabled"),e.$container.find(".btn-file, .fileinput-remove, .kv-fileinput-upload").removeAttr("disabled"),e.initDragDrop()},getExtraData:function(){var e=this,i=e.uploadExtraData;return"function"==typeof e.uploadExtraData&&(i=e.uploadExtraData()),i},uploadExtra:function(){var i=this,t=i.getExtraData();0!==t.length&&e.each(t,function(e,t){i.formdata.append(e,t)})},initXhr:function(e,i){var t=this;return e.upload&&e.upload.addEventListener("progress",function(e){var a=0,r=e.loaded||e.position,n=e.total;e.lengthComputable&&(a=Math.ceil(r/n*i)),t.uploadPercent=Math.max(a,t.uploadPercent),t.setProgress(t.uploadPercent)},!1),e},ajaxSubmit:function(i,t,a,r){var n,l=this;l.uploadExtra(),n=e.extend(l.ajaxSettings,{xhr:function(){var i=e.ajaxSettings.xhr();return l.initXhr(i,98)},url:l.uploadUrl,type:"POST",dataType:"json",data:l.formdata,cache:!1,processData:!1,contentType:!1,beforeSend:i,success:t,complete:a,error:r}),l.ajaxRequests.push(e.ajax(n))},uploadSingle:function(i,t,a){var r,l,o,s,d,p,c,f,u,v,h,m=this,g=m.getFileStack().length,w=new FormData,b=m.previewInitId+"-"+i,C=e("#"+b),x=C.find(".kv-file-upload"),y=C.find(".kv-file-remove"),$=C.find(".file-upload-indicator"),k=m.fileActionSettings,T=m.filestack.length>0||!e.isEmptyObject(m.uploadExtraData);m.formdata=w,0!==g&&T&&!x.hasClass("disabled")&&(s=function(){var e=m.$preview.find(".file-preview-frame.file-uploading"),i=e.length;i>0||(m.setProgress(100),m.unlock(),m.clearFileInput(),m.raise("filebatchuploadcomplete",[m.filestack,m.getExtraData()]))},d=function(e,i){$.html(k[e]),$.attr("title",k[i])},p=function(){!a||0===g||m.uploadPercent>=100||(m.uploadCount+=1,o=80+Math.ceil(20*m.uploadCount/g),m.uploadPercent=Math.max(o,m.uploadPercent),m.setProgress(m.uploadPercent),m.initPreviewDeletes())},c=function(){x.removeAttr("disabled"),y.removeAttr("disabled"),C.removeClass("file-uploading")},f=function(e){r=m.getOutData(e),d("indicatorLoading","indicatorLoadingTitle"),n(C,"file-uploading"),x.attr("disabled",!0),y.attr("disabled",!0),a||m.lock(),m.raise("filepreupload",[r,b,i])},u=function(e,t,n){r=m.getOutData(n,e),setTimeout(function(){void 0===e.error?(d("indicatorSuccess","indicatorSuccessTitle"),x.hide(),y.hide(),m.filestack[i]=void 0,a||m.resetFileStack(),m.raise("fileuploaded",[r,b,i])):(d("indicatorError","indicatorErrorTitle"),m.showUploadError(e.error,r,b,i))},100)},v=function(){setTimeout(function(){p(),c(),a?s():m.unlock(!1)},100)},h=function(e,n,o){d("indicatorError","indicatorErrorTitle"),r=m.getOutData(e),a?(l=t[i].name,m.showUploadError("<b>"+l+"</b>: "+o,r,b,i)):m.showUploadError(o,r,b,i)},w.append(m.uploadFileAttr,t[i]),w.append("file_id",i),m.ajaxSubmit(f,u,v,h))},uploadBatch:function(){var i,t,a,r,l,o,s,d,p=this,c=p.filestack,f=c.length,u=p.filestack.length>0||!e.isEmptyObject(p.uploadExtraData);p.formdata=new FormData,0!==f&&u&&(i=p.fileActionSettings,t=function(t,a,r){var n=e("#"+p.previewInitId+"-"+t).find(".file-upload-indicator");n.html(i[a]),n.attr("title",i[r])},r=function(i){var t=e("#"+p.previewInitId+"-"+i),a=t.find(".kv-file-upload"),r=t.find(".kv-file-delete");t.removeClass("file-uploading"),a.removeAttr("disabled"),r.removeAttr("disabled")},a=function(){e.each(c,function(e){p.filestack[e]=void 0}),p.clearFileInput()},l=function(i){p.lock();var t=p.getOutData(i);p.showPreview&&(p.$preview.find(".file-preview-frame").each(function(){var i=e(this),t=i.find(".kv-file-upload"),a=i.find(".kv-file-remove");n(i,"file-uploading"),t.attr("disabled",!0),a.attr("disabled",!0)}),p.raise("filebatchpreupload",[t]))},o=function(i,n,l){var o=p.getOutData(l,i),s=L(i.errorkeys)?[]:i.errorkeys;void 0===i.error||L(i.error)?(p.raise("filebatchuploadsuccess",[o]),a(),p.showPreview?(p.$preview.find(".kv-file-upload").hide(),p.$preview.find(".kv-file-remove").hide(),p.$preview.find(".file-preview-frame").each(function(){var i=e(this),a=i.attr("data-fileindex");t(a,"indicatorSuccess","indicatorSuccessTitle"),r(a)})):p.reset()):(p.$preview.find(".file-preview-frame").each(function(){var i=e(this),a=parseInt(i.attr("data-fileindex"),10);return r(a),0===s.length?void t(a,"indicatorError","indicatorErrorTitle"):void(-1!==e.inArray(a,s)?t(a,"indicatorError","indicatorErrorTitle"):(i.find(".kv-file-upload").hide(),i.find(".kv-file-remove").hide(),t(a,"indicatorSuccess","indicatorSuccessTitle"),p.filestack[a]=void 0))}),p.showUploadError(i.error,o,null,null,"filebatchuploaderror"))},s=function(){p.setProgress(100),p.unlock(),p.raise("filebatchuploadcomplete",[p.filestack,p.getExtraData()]),p.clearFileInput()},d=function(i,a,r){var n=p.getOutData(i);p.showUploadError(r,n,null,null,"filebatchuploaderror"),p.uploadFileCount=f-1,p.$preview.find(".file-preview-frame").each(function(){var i=e(this),a=i.attr("data-fileindex");i.removeClass("file-uploading"),void 0!==p.filestack[a]&&t(a,"indicatorError","indicatorErrorTitle")}),p.$preview.find(".file-preview-frame").removeClass("file-uploading"),p.$preview.find(".file-preview-frame kv-file-upload").removeAttr("disabled"),p.$preview.find(".file-preview-frame kv-file-delete").removeAttr("disabled")},e.each(c,function(e,i){L(c[e])||p.formdata.append(p.uploadFileAttr,i)}),p.ajaxSubmit(l,o,s,d))},uploadExtraOnly:function(){var e,i,t,a,r=this;e=function(e){r.lock();var i=r.getOutData(e);r.raise("filebatchpreupload",[i]),r.setProgress(50)},i=function(e,i,t){{var a=r.getOutData(t,e);L(e.errorkeys)?[]:e.errorkeys}void 0===e.error||L(e.error)?(r.raise("filebatchuploadsuccess",[a]),r.clearFileInput()):r.showUploadError(e.error,a,null,null,"filebatchuploaderror")},t=function(){r.setProgress(100),r.unlock(),r.raise("filebatchuploadcomplete",[r.filestack,r.getExtraData()]),r.clearFileInput()},a=function(e,i,t){var a=r.getOutData(e);r.showUploadError(t,a,null,null,"filebatchuploaderror")},r.ajaxSubmit(e,i,t,a)},hideFileIcon:function(){this.overwriteInitial&&this.$captionContainer.find(".kv-caption-icon").hide()},showFileIcon:function(){this.$captionContainer.find(".kv-caption-icon").show()},resetErrors:function(e){var i=this,t=i.$errorContainer;i.isError=!1,i.$container.removeClass("has-error"),t.html(""),e?t.fadeOut("slow"):t.hide()},showUploadError:function(e,i,t,a,r){var l=this,o=l.$errorContainer;return r=r||"fileuploaderror",0===o.find("ul").length?o.html('<ul class="text-left"><li>'+e+"</li></ul>"):o.find("ul").append("<li>"+e+"</li>"),o.fadeIn(800),l.raise(r,[i,t,a,l.reader]),n(l.$container,"has-error"),!0},showError:function(e,i,t,a,r,l){var o=this,s=o.$errorContainer;return r=r||"fileerror",l=l||{},s.html(e),s.fadeIn(800),o.raise(r,[i,t,a,o.reader,l]),o.isUploadable||o.clearFileInput(),n(o.$container,"has-error"),o.$btnUpload.attr("disabled",!0),!0},errorHandler:function(e,i){var t=this,a=e.target.error;switch(a.code){case a.NOT_FOUND_ERR:t.addError(t.msgFileNotFound.repl("{name}",i));break;case a.SECURITY_ERR:t.addError(t.msgFileSecured.repl("{name}",i));break;case a.NOT_READABLE_ERR:t.addError(t.msgFileNotReadable.repl("{name}",i));break;case a.ABORT_ERR:t.addError(t.msgFilePreviewAborted.repl("{name}",i));break;default:t.addError(t.msgFilePreviewError.repl("{name}",i))}},parseFileType:function(e){var i,t,a,r,n=this;for(r=0;r<U.length;r+=1)if(a=U[r],i=R(a,n.fileTypeSettings)?n.fileTypeSettings[a]:A[a],t=i(e.type,e.name)?a:"",!L(t))return t;return"other"},previewDefault:function(i,t,a){if(this.showPreview){var r=this,n=N.createObjectURL(i),l=e("#"+t),o=r.previewSettings.other,s=r.renderFileFooter(i.name,o.width),d=r.getPreviewTemplate("other"),p=t.slice(t.lastIndexOf("-")+1),c="";a===!0&&(c=" btn disabled",s+='<div class="file-other-error text-danger"><i class="glyphicon glyphicon-exclamation-sign"></i></div>'),r.$preview.append("\n"+d.repl("{previewId}",t).repl("{frameClass}",c).repl("{fileindex}",p).repl("{caption}",r.slug(i.name)).repl("{width}",o.width).repl("{height}",o.height).repl("{type}",i.type).repl("{data}",n).repl("{footer}",s)),l.on("load",function(){N.revokeObjectURL(l.attr("data"))})}},previewFile:function(e,i,t,a){if(this.showPreview){var r,n,l,o,s=this,d=s.parseFileType(e),p=s.slug(e.name),c=s.allowedPreviewTypes,f=s.allowedPreviewMimeTypes,u=R(d,s.previewTemplates)?s.previewTemplates[d]:S[d],v=R(d,s.previewSettings)?s.previewSettings[d]:j[d],h=parseInt(s.wrapTextLength,10),m=s.wrapIndicator,g=c.indexOf(d)>=0,w=L(f)||!L(f)&&R(e.type,f),b=s.renderFileFooter(p,v.width),C="",x=t.slice(t.lastIndexOf("-")+1);g&&w?("text"===d?(n=Z(i.target.result),N.revokeObjectURL(a),n.length>h&&(l="text-"+M(),o=.75*window.innerHeight,C=s.getLayoutTemplate("modal").repl("{id}",l).repl("{title}",p).repl("{height}",o).repl("{body}",n),m=m.repl("{title}",p).repl("{dialog}","$('#"+l+"').modal('show')"),n=n.substring(0,h-1)+m),r=u.repl("{previewId}",t).repl("{caption}",p).repl("{frameClass}","").repl("{type}",e.type).repl("{width}",v.width).repl("{height}",v.height).repl("{data}",n).repl("{footer}",b).repl("{fileindex}",x)+C):r=u.repl("{previewId}",t).repl("{caption}",p).repl("{frameClass}","").repl("{type}",e.type).repl("{data}",a).repl("{width}",v.width).repl("{height}",v.height).repl("{footer}",b).repl("{fileindex}",x),s.$preview.append("\n"+r),s.autoSizeImage(t)):s.previewDefault(e,t)}},slugDefault:function(e){return L(e)?"":e.split(/(\\|\/)/g).pop().replace(/[^\w\-.\\\/ ]+/g,"")},getFileStack:function(){var e=this;return e.filestack.filter(function(e){return void 0!==e})},readFiles:function(e){function i(h){if(L(a.attr("multiple"))&&(c=1),h>=c)return l.removeClass("loading"),void o.html("");var m,g,w,b,C,x,y=u+h,$=p+"-"+y,k=e[h],T=t.slug(k.name),E=(k.size||0)/1e3,F="",P=N.createObjectURL(k),I=0,D=t.allowedFileTypes,S=L(D)?"":D.join(", "),U=t.allowedFileExtensions,j=L(U)?"":U.join(", ");if(L(U)||(F=new RegExp("\\.("+U.join("|")+")$","i")),E=E.toFixed(2),t.maxFileSize>0&&E>t.maxFileSize)return b=t.msgSizeTooLarge.repl("{name}",T).repl("{size}",E).repl("{maxSize}",t.maxFileSize),void(t.isError=v(b,k,$,h));if(!L(D)&&O(D)){for(w=0;w<D.length;w+=1)C=D[w],g=f[C],x=void 0!==g&&g(k.type,T),I+=L(x)?0:x.length;if(0===I)return b=t.msgInvalidFileType.repl("{name}",T).repl("{types}",S),void(t.isError=v(b,k,$,h))}return 0!==I||L(U)||!O(U)||L(F)||(x=T.match(F),I+=L(x)?0:x.length,0!==I)?t.showPreview?(r.length>0&&void 0!==FileReader?(o.html(s.repl("{index}",h+1).repl("{files}",c)),l.addClass("loading"),n.onerror=function(e){t.errorHandler(e,T)
},n.onload=function(e){t.previewFile(k,e,$,P),t.initFileActions()},n.onloadend=function(){b=d.repl("{index}",h+1).repl("{files}",c).repl("{percent}",50).repl("{name}",T),setTimeout(function(){o.html(b),N.revokeObjectURL(P)},100),setTimeout(function(){i(h+1),t.updateFileDetails(c)},100),t.raise("fileloaded",[k,$,h,n])},n.onprogress=function(e){if(e.lengthComputable){var i=e.loaded/e.total*100,t=Math.ceil(i);b=d.repl("{index}",h+1).repl("{files}",c).repl("{percent}",t).repl("{name}",T),setTimeout(function(){o.html(b)},100)}},m=R("text",f)?f.text:A.text,m(k.type,T)?n.readAsText(k,t.textEncoding):n.readAsArrayBuffer(k)):(t.previewDefault(k,$),setTimeout(function(){i(h+1),t.updateFileDetails(c)},100),t.raise("fileloaded",[k,$,h,n])),void t.filestack.push(k)):(t.filestack.push(k),setTimeout(i(h+1),100),void t.raise("fileloaded",[k,$,h,n])):(b=t.msgInvalidFileExtension.repl("{name}",T).repl("{extensions}",j),void(t.isError=v(b,k,$,h)))}this.reader=new FileReader;var t=this,a=t.$element,r=t.$preview,n=t.reader,l=t.$previewContainer,o=t.$previewStatus,s=t.msgLoading,d=t.msgProgress,p=t.previewInitId,c=e.length,f=t.fileTypeSettings,u=t.filestack.length,v=function(i,a,r,n){t.previewDefault(a,r,!0);var l=t.getOutData({},{},e);return t.isUploadable?t.showUploadError(i,l,r,n):t.showError(i,a,r,n)};i(0),t.updateFileDetails(c,!1)},updateFileDetails:function(e){var i=this,t=i.msgSelected,a=i.$element,r=i.getFileStack(),n=a.val()||r.length&&r[0].name||"",l=i.slug(n),o=i.isUploadable?r.length:e,s=i.initialPreviewCount+o,d=o>1?t.repl("{n}",s):l;i.isError?(i.$previewContainer.removeClass("loading"),i.$previewStatus.html(""),i.$captionContainer.find(".kv-caption-icon").hide(),d=i.msgValidationError):i.showFileIcon(),i.setCaption(d),i.$container.removeClass("file-input-new file-input-ajax-new"),1===arguments.length&&i.raise("fileselect",[e,l])},change:function(e){var i,t,a,r=this,n=r.$element,l=r.$preview,o=arguments.length>1,s=o?e.originalEvent.dataTransfer.files:n.get(0).files,d=L(n.attr("multiple")),p=r.filestack.length,c=r.isUploadable&&0!==p,f=function(e,i,t,a){var n=r.getOutData({},{},s);return r.isUploadable?r.showUploadError(e,n,t,a):r.showError(e,i,t,a)};return r.resetUpload(),r.hideFileIcon(),r.$container.find(".file-drop-zone ."+r.dropZoneTitleClass).remove(),i=o?s:void 0===e.target.files?e.target&&e.target.value?[{name:e.target.value.replace(/^.+\\/,"")}]:[]:e.target.files,L(i)||0===i.length?(c||r.clear(!0),void r.raise("fileselectnone")):(r.resetErrors(),(!c||d&&p>0)&&(l.html(r.overwriteInitial?"":r.initialPreviewContent),d&&p>0&&(r.filestack=[])),a=r.isUploadable?r.getFileStack().length+i.length:i.length,r.maxFileCount>0&&a>r.maxFileCount?(t=r.msgFilesTooMany.repl("{m}",r.maxFileCount).repl("{n}",a),r.isError=f(t,null,null,null),r.$captionContainer.find(".kv-caption-icon").hide(),r.$caption.html(r.msgValidationError),r.setEllipsis(),void r.$container.removeClass("file-input-new file-input-ajax-new")):(r.isIE9?r.updateFileDetails(1):r.readFiles(i),c?r.raise("filebatchselected",[r.getFileStack()]):r.raise("filebatchselected",[i]),void(r.reader=null)))},autoSizeImage:function(e){var i,t,a,r=this,n=r.$preview,l=n.find("#"+e),o=l.find("img");o.length&&o.on("load",function(){i=l.width(),t=n.width(),i>t&&(o.css("width","100%"),l.css("width","97%")),a=o.closest(".file-preview-frame").find(".file-caption-name"),a.length&&(a.width(o.width()),a.attr("title",a.text())),r.raise("fileimageloaded",e)})},setCaption:function(i){var t=this,a=e("<div>"+i+"</div>").text(),r=t.getLayoutTemplate("icon"),n=r+a;0!==t.$caption.length&&(t.$caption.html(n),t.$caption.attr("title",a),t.$captionContainer.find(".file-caption-ellipsis").attr("title",a),t.setEllipsis())},initBrowse:function(e){var i=this;i.$btnFile=e.find(".btn-file"),i.$btnFile.append(i.$element)},createContainer:function(){var i=this,t=e(document.createElement("span")).attr({"class":"file-input file-input-new"}).html(i.renderMain());return i.$element.before(t),i.initBrowse(t),t},refreshContainer:function(){var e=this,i=e.$container;i.before(e.$element),i.html(e.renderMain()),e.initBrowse(i)},renderMain:function(){var e=this,i=e.isUploadable&&e.dropZoneEnabled?" file-drop-zone":"",t=e.showPreview?e.getLayoutTemplate("preview").repl("{class}",e.previewClass).repl("{dropClass}",i):"",a=e.isDisabled?e.captionClass+" file-caption-disabled":e.captionClass,r=e.captionTemplate.repl("{class}",a+" kv-fileinput-caption");return e.mainTemplate.repl("{class}",e.mainClass).repl("{preview}",t).repl("{caption}",r).repl("{upload}",e.renderUpload()).repl("{remove}",e.renderRemove()).repl("{cancel}",e.renderCancel()).repl("{browse}",e.renderBrowse())},renderBrowse:function(){var e=this,i=e.browseClass+" btn-file",t="";return e.isDisabled&&(t=" disabled "),'<div class="'+i+'"'+t+"> "+e.browseIcon+e.browseLabel+" </div>"},renderRemove:function(){var e=this,i=e.removeClass+" fileinput-remove fileinput-remove-button",t="";return e.showRemove?(e.isDisabled&&(t=" disabled "),'<button type="button" title="'+e.removeTitle+'" class="'+i+'"'+t+">"+e.removeIcon+e.removeLabel+"</button>"):""},renderCancel:function(){var e=this,i=e.cancelClass+" fileinput-cancel fileinput-cancel-button";return e.showCancel?'<button type="button" title="'+e.cancelTitle+'" class="hide '+i+'">'+e.cancelIcon+e.cancelLabel+"</button>":""},renderUpload:function(){var e=this,i=e.uploadClass+" kv-fileinput-upload fileinput-upload-button",t="",a="";return e.showUpload?(e.isDisabled&&(a=" disabled "),t=!e.isUploadable||e.isDisabled?'<button type="submit" title="'+e.uploadTitle+'"class="'+i+'"'+a+">"+e.uploadIcon+e.uploadLabel+"</button>":'<a href="'+e.uploadUrl+'" title="'+e.uploadTitle+'" class="'+i+'"'+a+">"+e.uploadIcon+e.uploadLabel+"</a>"):""}},e.fn.fileinput=function(a){if(t()||i(9)){var r=Array.apply(null,arguments);return r.shift(),this.each(function(){var i=e(this),t=i.data("fileinput"),n="object"==typeof a&&a;t||(t=new _(this,e.extend({},e.fn.fileinput.defaults,n,e(this).data())),i.data("fileinput",t)),"string"==typeof a&&t[a].apply(t,r)})}},e.fn.fileinput.defaults={showCaption:!0,showPreview:!0,showRemove:!0,showUpload:!0,showCancel:!0,mainClass:"",previewClass:"",captionClass:"",mainTemplate:null,initialCaption:"",initialPreview:"",initialPreviewCount:0,initialPreviewDelimiter:"*$$*",initialPreviewConfig:[],initialPreviewShowDelete:!0,overwriteInitial:!0,layoutTemplates:D,previewTemplates:S,allowedPreviewTypes:U,allowedPreviewMimeTypes:null,allowedFileTypes:null,allowedFileExtensions:null,customLayoutTags:{},customPreviewTags:{},previewSettings:j,fileTypeSettings:A,browseLabel:"Browse &hellip;",browseIcon:'<i class="glyphicon glyphicon-folder-open"></i> &nbsp;',browseClass:"btn btn-primary",removeLabel:"Remove",removeTitle:"Clear selected files",removeIcon:'<i class="glyphicon glyphicon-trash"></i> ',removeClass:"btn btn-default",cancelLabel:"Cancel",cancelTitle:"Abort ongoing upload",cancelIcon:'<i class="glyphicon glyphicon-ban-circle"></i> ',cancelClass:"btn btn-default",uploadLabel:"Upload",uploadTitle:"Upload selected files",uploadIcon:'<i class="glyphicon glyphicon-upload"></i> ',uploadClass:"btn btn-default",uploadUrl:null,uploadAsync:!0,uploadExtraData:{},deleteExtraData:{},maxFileSize:0,maxFileCount:0,msgSizeTooLarge:'File "{name}" (<b>{size} KB</b>) exceeds maximum allowed upload size of <b>{maxSize} KB</b>. Please retry your upload!',msgFilesTooMany:"Number of files selected for upload <b>({n})</b> exceeds maximum allowed limit of <b>{m}</b>. Please retry your upload!",msgFileNotFound:'File "{name}" not found!',msgFileSecured:'Security restrictions prevent reading the file "{name}".',msgFileNotReadable:'File "{name}" is not readable.',msgFilePreviewAborted:'File preview aborted for "{name}".',msgFilePreviewError:'An error occurred while reading the file "{name}".',msgInvalidFileType:'Invalid type for file "{name}". Only "{types}" files are supported.',msgInvalidFileExtension:'Invalid extension for file "{name}". Only "{extensions}" files are supported.',msgValidationError:'<span class="text-danger"><i class="glyphicon glyphicon-exclamation-sign"></i> File Upload Error</span>',msgErrorClass:"file-error-message",msgLoading:"Loading  file {index} of {files} &hellip;",msgProgress:"Loading file {index} of {files} - {name} - {percent}% completed.",msgSelected:"{n} files selected",progressClass:"progress-bar progress-bar-success progress-bar-striped active",progressCompleteClass:"progress-bar progress-bar-success",previewFileType:"image",wrapTextLength:250,wrapIndicator:' <span class="wrap-indicator" title="{title}" onclick="{dialog}">[&hellip;]</span>',elCaptionContainer:null,elCaptionText:null,elPreviewContainer:null,elPreviewImage:null,elPreviewStatus:null,elErrorContainer:null,slugCallback:null,dropZoneEnabled:!0,dropZoneTitle:"Drag & drop files here &hellip;",dropZoneTitleClass:"file-drop-zone-title",fileActionSettings:{},otherActionButtons:"",textEncoding:"UTF-8",ajaxSettings:{}},e.fn.fileinput.Constructor=_,e(document).ready(function(){var i=e("input.file[type=file]"),t=i.attr("type")?i.length:0;t>0&&i.fileinput()})}(window.jQuery);